import * as t from '@babel/types';
import { AttributeItem } from './base-builder';
export declare const BINDING_CONTEXT_PROPERTY_NAME = "bindingContext";
export declare const VIEW_MODEL_REFERENCE_NAME = "viewModel";
export declare const VALUE_REFERENCE_NAME = "$value";
export declare const PARENT_REFERENCE_NAME = "$parent";
export declare const PARENTS_REFERENCE_NAME = "$parents";
export declare const SPECIAL_REFERENCES: string[];
export interface BindingOptions {
    viewPropertyDetails: AttributeItem;
    properties: Array<string>;
    astExpression: t.Expression;
    isTwoWay: boolean;
    converterToModelAstExpression?: t.SequenceExpression;
    specialReferenceCount: number;
    parentKeyAstExpressions: Array<t.Expression>;
    [Symbol.toStringTag]: string;
}
export declare class BindingBuilder {
    isBindingValue(value: string): boolean;
    convertValueToBindingOptions(propertyDetails: AttributeItem): BindingOptions;
    private getEventExpressionWithContext;
    private checkIfBindingExpressionIsValid;
    private handleIdentifier;
    private handleConverter;
    private getAstForParentKey;
    private getBindingCode;
    private isCallExpression;
    private isConverterExpression;
    private isMemberExpression;
    private isTwoWayBindingExpression;
}
