"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertDocumentToAST = void 0;
const t = __importStar(require("@babel/types"));
const htmlparser2_1 = require("htmlparser2");
const component_builder_1 = require("./builders/component-builder");
function getAstForRawXML(content) {
    return t.program([
        t.variableDeclaration('const', [
            t.variableDeclarator(t.identifier('RAW_XML_CONTENT'), t.stringLiteral(content))
        ]),
        t.exportDefaultDeclaration(t.identifier('RAW_XML_CONTENT'))
    ], [], 'module');
}
function convertDocumentToAST(content, builderOpts) {
    const componentBuilder = new component_builder_1.ComponentBuilder(builderOpts);
    let compilationResult;
    let needsCompilation = true;
    const xmlParser = new htmlparser2_1.Parser({
        onopentag(tagName, attributes) {
            componentBuilder.handleOpenTag(tagName, attributes);
        },
        onprocessinginstruction(name) {
            if (name == '?xml') {
                needsCompilation = false;
                xmlParser.reset();
            }
        },
        onclosetag(tagName) {
            componentBuilder.handleCloseTag(tagName);
        },
        onerror(err) {
            throw err;
        }
    }, {
        xmlMode: true
    });
    xmlParser.write(content);
    xmlParser.end();
    if (needsCompilation) {
        compilationResult = {
            output: componentBuilder.getModuleAst(),
            pathsToResolve: componentBuilder.getPathsToResolve()
        };
    }
    else {
        compilationResult = {
            output: getAstForRawXML(content),
            pathsToResolve: []
        };
    }
    return compilationResult;
}
exports.convertDocumentToAST = convertDocumentToAST;
//# sourceMappingURL=xml-parser.js.map